﻿using GrapeCity.Windows.SpreadGrid;
using GrapeCity.Windows.SpreadGrid.Editors;
using GrapeCity.Windows.SpreadGrid.Presenters;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SpreadSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private ViewModel _viewModel;
        private bool _isDragging = false;
        private int initialRow;
        public MainWindow()
        {
            InitializeComponent();
            _viewModel = new ViewModel();
            DataContext = _viewModel;
            gcSpreadGrid1.PreviewMouseDown += GcSpreadGrid1_PreviewMouseDown;
            gcSpreadGrid1.PreviewMouseMove += GcSpreadGrid1_MouseMove;
            gcSpreadGrid1.PreviewMouseUp += GcSpreadGrid1_PreviewMouseUp;
            
        }

        private void GcSpreadGrid1_PreviewMouseUp(object sender, MouseButtonEventArgs e)
        {
            _isDragging = false;
        }

        private void GcSpreadGrid1_MouseMove(object sender, MouseEventArgs e)
        {
            if(_isDragging & e.LeftButton == MouseButtonState.Pressed)
            {
                var hitTest = gcSpreadGrid1.HitTest(e.GetPosition(gcSpreadGrid1)) as CellHitTestInfo;
                
                if(hitTest !=null)
                {
                    if (initialRow > hitTest.RowIndex & GetViewBottomRow() + 1 != gcSpreadGrid1.Rows.Count)
                        gcSpreadGrid1.ShowRow(GetViewTopRow() + 1, VerticalPosition.Top);

                    else if (initialRow < hitTest.RowIndex & GetViewTopRow() != 0)
                        gcSpreadGrid1.ShowRow(GetViewBottomRow() - 1, VerticalPosition.Bottom);
                }                
                e.Handled = true;
            }
        }

        private int GetViewTopRow()
        {
            int topmostRow = 0;
            for (int row = 0; row < gcSpreadGrid1.Rows.Count; row++)
            {
                for (int col = 0; col < gcSpreadGrid1.Columns.Count; col++)
                {
                    if (gcSpreadGrid1.IsCellInView(row, col))
                    {
                        topmostRow = row;
                        row = gcSpreadGrid1.Rows.Count;
                        break;
                    }
                }
            }
            return topmostRow;
        }
        private int GetViewBottomRow()
        {
            int bottomMostRow = 0;
            for (int row = gcSpreadGrid1.Rows.Count-1; row >= 0; row--)
            {
                for (int col = 0; col < gcSpreadGrid1.Columns.Count; col++)
                {
                    if (gcSpreadGrid1.IsCellInView(row, col))
                    {
                        bottomMostRow = row;
                        row = -1;
                        break;
                    }
                }
            }
            return bottomMostRow;
        }

        private void GcSpreadGrid1_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            _isDragging = true;

            var ht = gcSpreadGrid1.HitTest(e.GetPosition(gcSpreadGrid1)) as CellHitTestInfo;
            if(ht != null)
                initialRow = ht.RowIndex;
        }
    }
}
