﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SpreadSample
{
    public class ViewModel: INotifyPropertyChanged
    {
        private bool _rowHeaderVisibility;

        public List<User> Users { get; set; }

        public bool RowHeaderVisiblity
        {
            get
            {
                return _rowHeaderVisibility;
            }
            set
            {
                _rowHeaderVisibility = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(nameof(RowHeaderVisiblity)));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public ViewModel()
        {
            _rowHeaderVisibility = true;
            Users = new List<User>();
            Users.Add(new User() { Id = 1, Name = "John" });
            Users.Add(new User() { Id = 2, Name = "Kyle" });
            Users.Add(new User() { Id = 3, Name = "Bob" });
            Users.Add(new User() { Id = 4, Name = "Marie" });
        }
    }
}
